<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Veranstalter\KursUebersicht\Detailsreiter\Teilnehmer;

class TeilnehmerController extends \Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\Teilnehmer\TeilnehmerController
{
  private $changedBelegungen;
  private $statusMessage;

  public function __construct($pChangedBelegungen = null, $pStatusMessage = null)
  {
    $this->changedBelegungen = $pChangedBelegungen;
    $this->statusMessage = $pStatusMessage;
  }

  protected function getUseCase(): \Kufer\Web\KuferTools\Basis\UseCase\UseCase
  {
    return new TeilnehmerUseCase(
      $this->getRequestObj()
    );
  }

  protected function getRequestObj()
  {
    $requestObj = new TeilnehmerRequest();
    $requestObj->knr = \GetOperations::getVarValue('knr');
    $requestObj->changedBelegungen = $this->changedBelegungen;
    $requestObj->statusMessage = $this->statusMessage;

    return $requestObj;
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return new TeilnehmerPresenter($pUseCaseResponse);
  }
}